unit Unit1;

{$MODE objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, x, xlib, xutils, xutil,
  ExtCtrls, StdCtrls, Contnrs;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    PaintBox1: TPaintBox;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    Net_Wm_Pid: TAtom;
    Wm_Client_machine: TAtom;
    aDisplay: XLib.PDisplay;
    WindowList: TObjectList;
    procedure DisplayWindowInfo(Display: XLib.PDisplay; Window: TWindow; Param: Pointer);
  end;

  TWindowInfo = class
    Rect: TRect;
      Name: string;
  end;

var
  Form1: TForm1;

implementation


{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  aDisplay := XOpenDisplay(Pchar(GetEnvironmentVariable('DISPLAY')));
  if not Assigned(aDisplay) then Exit;
  Wm_Client_machine := XInternAtom(aDisplay, 'WM_CLIENT_MACHINE', LongBool(1));
  Net_Wm_Pid := XInternAtom(aDisplay, '_NET_WM_PID', LongBool(1));
  WindowList := TObjectList.Create;
  WindowList.OwnsObjects := true;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  WindowList.Clear;
  EnumTopLevelWindows(@DisplayWindowInfo, nil);
  PaintBox1.Repaint;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  WindowList.free;
  if Assigned(aDisplay) then XCloseDisplay(aDisplay);
end;

function ScaleRect(aRect: TRect; divi: integer): TRect;
begin
  Result.Left := aRect.Left div divi;
  Result.Top := aRect.Top div divi;
  Result.Bottom := aRect.bottom div divi;
  Result.Right := aRect.Right div divi;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var i: integer;
  g: Byte;
  grays: integer;
  ScaledR: TRect;
begin
  PaintBox1.Canvas.Font.Size := 10;
  PaintBox1.Canvas.Font.Color := clwhite;
  if WindowList.Count > 0 then
  begin
    if WindowList.Count < 255 then grays := (255 div WindowList.Count) else grays := 1;
    for i := 0 to WindowList.Count - 1 do
    begin
      g := i * grays;
      ScaledR := ScaleRect(TWindowInfo(WindowList[i]).Rect, 2);
      if i = 0 then PaintBox1.Canvas.Brush.Color := clyellow else
      begin
        PaintBox1.Canvas.Brush.Color := clnavy;
        PaintBox1.Canvas.FillRect(ScaledR.Left, ScaledR.Top - 11, ScaledR.Right, ScaledR.Top);
        PaintBox1.Canvas.TextRect(Rect(ScaledR.Left, ScaledR.Top - 11, ScaledR.Right, ScaledR.Top), ScaledR.Left + 1, ScaledR.Top - 9, TWindowInfo(WindowList[i]).Name);
        PaintBox1.Canvas.Brush.Color := RGBToColor(g, g, g);
      end;
      PaintBox1.Canvas.FillRect(ScaledR);
      PaintBox1.Canvas.Rectangle(ScaledR);
    end;
  end;
end;

procedure TForm1.DisplayWindowInfo(Display: XLib.PDisplay; Window: TWindow;
  Param: Pointer);
var
  aName: PChar;
  Host: string;
  Pid: Cardinal;
  Stat: XLib.TStatus;
  Attrs: TXWindowAttributes;
  junk: TWindow;
  rx, ry: integer;
  tmpw: TWindowInfo;
begin
  if XFetchName(Display, Window, @aName) <> 0 then
  begin

    if GetState(Display, Window) = NormalState then
    begin

      Stat := XGetWindowAttributes(Display, Window, @Attrs);

      if Stat <> 0 then
      begin
        XTranslateCoordinates(Display, Window, Attrs.root,
          Attrs.border_width,
          Attrs.border_width,
          @rx, @ry, @junk);
        tmpw := TWindowInfo.Create;
        tmpw.Rect.Left := rx;
        tmpw.Rect.Top := ry;
        tmpw.Rect.Bottom := Attrs.height + ry;
        tmpw.Rect.Right := Attrs.width + rx;
        tmpw.Name := aName;
        WindowList.Add(tmpw);
      end;
    end;

  end;
end;

initialization
{$I unit1.lrs}

end.
